unit hiEditEx;

interface

uses Kol,Share,Win,Windows,Messages;

type
  Tfunc = function(const s:string; var dt:TData):boolean;
  THIEditEx = class(THIWin)
   private

    FCaption: PControl;
    FBtn: PControl;
    FPB: PControl;
    FCapInit: boolean;
    OldPaint: TOnPaint;
    FOld:string;
    FPos:integer;
    ChangeEvent:boolean;
    IdxPassSym: Integer;
    FtxtMarg: DWORD;
    FCapFont: PGraphicTool;
    function NoText(func:Tfunc; var dt:TData):boolean;
    procedure _OnChange(Obj:PObj);
    procedure _OnKeyDown(Sender: PControl; var Key: Longint; Shift: DWORD); override;
    function  _onMessage(var Msg: TMsg; var Rslt: Integer): Boolean; override;
    procedure _OnPaint(Sender: PControl; DC: HDC);
    procedure OnEraseBkgnd(Sender: PControl; DC: HDC);
    procedure OnClick(Obj:PObj);
    procedure SetHelp;
    procedure AddBtn;
    procedure CalcRect;
   public
    _prop_DataType:function(var dt:Tdata):boolean of object;
    _prop_Password:boolean;
    _prop_ClearAfterEnter: boolean;
    _prop_Text:string;
    _prop_ReadOnly:boolean;
    _prop_Alignment:byte;
    _prop_MaxLenField:integer;
    _prop_OnChngDelNumEnd:boolean;

    _prop_Caption: string;
    _prop_FontCaption: TFontRec;
    _prop_CapPosition: byte;
    _prop_akRight: boolean;
    _prop_HelpData: string;
    _prop_AddBtn: boolean;
    _prop_BtnIcon: byte;
    _prop_IconIdx: integer;
    _prop_ValidIdx: integer;
    _prop_UseIcon: HBITMAP;

    _data_Str:THI_Event;
    _event_onEnter:THI_Event;
    _event_onChange:THI_Event;
    _event_OnClickBtn:THI_Event;

    constructor Create(Parent:PControl);
    procedure Init; override;

    function Text(var dt:Tdata):boolean;
    function Number(var dt:Tdata):boolean;
    function IntegerNumber(var dt:Tdata):boolean;
    function HexNumber(var dt:Tdata):boolean;
    function FloatNumber(var dt:Tdata):boolean;

    //procedure _work_doSet(var _Data:TData; Index: word);

    procedure _work_doText(var _Data:TData; Index:word);
    procedure _work_doText2(var _Data:TData; Index:word);
    procedure _work_doPosition(var _Data:TData; Index:word);
    procedure _work_doSelectLength(var _Data:TData; Index:word);
    procedure _work_doSelectText(var _Data:TData; Index:word);
    procedure _work_doSelectAll(var _Data:TData; Index:word);
    procedure _work_doReadOnly(var _Data:TData; Index:word);
    procedure _work_doMaxLenField(var _Data:TData; Index:word);
    procedure _work_doPassword(var _Data:TData; Index:word);
    procedure _work_doValidInput(var _Data:TData; Index:word);
    procedure _work_doSelectIconFromIndex(var _Data:TData; Index:word);
    procedure _var_Text(var _Data:TData; Index:word);

    //********************* FASTED ***************************
    function _fast_Text:string;
  end;

  function ExtractIconEx(lpszFile: PChar; nIconIndex: Integer;
    var phiconLarge, phiconSmall: HICON; nIcons: UINT): UINT; stdcall;
    external  'shell32.dll' name 'ExtractIconExA';

  procedure LoadFromBitmap(Bmp: Kol.PBitmap; Icon: Kol.PIcon; ATransparent: TColor);
  procedure TFontToGFont(Font: TFontRec; GrFont: PGraphicTool);

implementation

uses
  IconMemory;

const
  EM_SETCUEBANNER = $1501;

procedure TFontToGFont(Font: TFontRec; GrFont: PGraphicTool);
begin
  GrFont.Color:= Font.Color;
  Share.SetFont(GrFont,Font.Style);
  GrFont.FontName:= Font.Name;
  GrFont.FontHeight:= _hi_SizeFnt(Font.Size);
  GrFont.FontCharset:= Font.CharSet;
end;

function StringToWideString(const s: String): WideString;
var
  len: integer;
const
  codePage = 3;
begin
  Result := '';
  if s = '' then exit;
  len := MultiByteToWideChar(codePage, MB_PRECOMPOSED, PChar(@s[1]), -1, nil, 0);
  SetLength(Result, (len - 1){$ifdef F_P}*2{$endif});
  if len <= 1 then exit;
  MultiByteToWideChar(CodePage, MB_PRECOMPOSED, PChar(@s[1]), -1, PWideChar(@Result[1]), len);
end;


procedure THIEditEx.SetHelp;
var
  ws: widestring;
begin
  if _prop_HelpData <> '' then
  begin
    ws := '   ' + StringToWideString(_prop_HelpData);
    Sendmessage(Control.Handle, EM_SETCUEBANNER, 0, Integer(Pwidechar(ws)));
  end;
end;

procedure THIEditEx._work_doValidInput;
begin
  _prop_ValidIdx := ToInteger(_Data);
  if _prop_ValidIdx >= 0 then
  begin
    FPB.Width := Control.Height;
    FPB.Clear;
    Control.Perform(EM_SETMARGINS, EC_LEFTMARGIN, MakeLong(FPB.Width,HiWord(FtxtMarg)));
    FPB.Invalidate;
  end else begin
    FPB.Width := 0;
    Control.Perform(EM_SETMARGINS, EC_LEFTMARGIN, MakeLong(LoWord(FtxtMarg),HiWord(FtxtMarg)));
  end;
end;

procedure THIEditEx.OnClick(Obj: PObj);
var
  R: TRect;
  Res: integer;
begin
  SetFocus(0);
  GetWindowRect(FBtn.Handle,R);
  Res := (R.Bottom*65536)+R.Left;
  _hi_onEvent(_event_onClickBtn,Res);
end;

procedure THIEditEx._work_doSelectIconFromIndex;
var
  idx: integer;
  Licon,sIcon: hIcon;
begin
  if (_prop_BtnIcon > 3) and (_prop_AddBtn = True) then
  begin
    idx := ToInteger(_Data);

    if _prop_BtnIcon = 4 then
      ExtractIconEx('shell32.dll',idx,Licon,sIcon,1);

    if _prop_BtnIcon = 5 then
      ExtractIconEx('imageres.dll',idx,Licon,sIcon,1);

    FBtn.SetButtonIcon(sIcon);
    FBtn.Invalidate;
  end;
end;

procedure THIEditEx.OnEraseBkgnd(Sender: PControl; DC: HDC);
var
  R: TRect;
begin
  R := FPB.ClientRect;
  FPB.Canvas.Brush.Color := Control.Color;
  FPB.Canvas.Brush.BrushStyle := bsSolid;
  FPB.Canvas.FillRect(R);
end;

procedure THIEditEx._OnPaint(Sender: PControl; DC: HDC);
begin
  if _prop_ValidIdx <> -1 then
  begin
    case _prop_ValidIdx of
       0: iMarkIcon.Draw(FPB.Canvas.Handle,0,0);
       1: iApplyIcon.Draw(FPB.Canvas.Handle,0,0);
       2: iApplyIcon2.Draw(FPB.Canvas.Handle,0,0);
    end;
  end;
end;


function THIEditEx._onMessage;
var
  R: TRect;
  Bmp: Kol.PBitmap;
  w,h: integer;
begin
  Result := False;
  case Msg.message of
    WM_SIZE,WM_MOVE:
    begin
      if FCapInit then
      begin
        //left
        if _prop_CapPosition = 0 then
        begin
          FCaption.Left := (Control.Left - Control.Canvas.TextWidth(_prop_Caption))-5;
          FCaption.Top := Control.Top;
        end;
        //top
        if _prop_CapPosition = 1 then
        begin
          FCaption.Left := Control.Left;
          FCaption.Top := Control.Top - FCaption.Height;
        end;
        //right
        if _prop_CapPosition = 2 then
        begin
          FCaption.Left := (Control.Left+Control.Width)+5;
          FCaption.Top := Control.Top;
        end;

      end;
    end;

  end;
  Result := Result or inherited _onMessage(Msg,Rslt);
end;

constructor THIEditEx.Create;
begin
   inherited Create(Parent);
   FOld := '';
   FPos := 0;
end;

procedure LoadFromBitmap(Bmp: Kol.PBitmap; Icon: Kol.PIcon; ATransparent: TColor);
var
  mask,body: Kol.PBitmap;
  i,j:integer;
  IconInfo: TIconInfo;
begin
  if bmp <> nil then
  begin
     body := NewBitmap(0,0);
     Body.Assign(bmp);
     Mask := NewBitmap(bmp.Width,bmp.Height);
     Mask.Assign(bmp);
     Mask.Convert2Mask(ATransparent);

     for i := 0 to bmp.Width-1 do
       for j := 0 to bmp.Height-1 do
         if Body.Canvas.Pixels[i,j] = ATransparent then
           Body.Canvas.Pixels[i,j] := clBlack;

     if Icon = nil then
       Icon := NewIcon;

     IconInfo.fIcon := True;
     IconInfo.xHotspot := 0;
     IconInfo.yHotspot := 0;
     IconInfo.hbmMask := Mask.Handle;
     IconInfo.hbmColor := Body.Handle;
     Icon.Handle := CreateIconIndirect(IconInfo);
     Mask.Free;
     Body.Free;
  end;
end;

procedure THIEditEx.AddBtn;
var
  Bmp: Kol.PBitmap;
  Icon16: Kol.PIcon;
  Licon,sIcon: hIcon;
  R: TRect;
begin
   if _prop_AddBtn then
   begin
     if FBtn = nil then
       FBtn := NewButton(Control,'');
     FBtn.TabOrder := -1;
     FBtn.Style := FBtn.Style and (not WS_TABSTOP);
     if _prop_CapPosition = 1 then
       FBtn.Width := Max(24,Control.Height-FCaption.Height)
     else
       FBtn.Width := Control.Height;

     if Control.TextAlign = taRight then
     begin
       FBtn.Align := caLeft;
       Control.Perform(EM_SETMARGINS, EC_LEFTMARGIN, MakeLong(FBtn.Width,0));
     end else begin
       FBtn.Align := caRight;
       Control.Perform(EM_SETMARGINS, EC_RIGHTMARGIN, MakeLong(0,FBtn.Width));
     end;

     Bmp := NewBitmap(16,16);
     Bmp.Canvas.Brush.Color := Control.Color;
     Bmp.Canvas.Brush.BrushStyle := bsSolid;
     Bmp.Canvas.FillRect(R);

     case _prop_BtnIcon of
       0: FBtn.Caption := '...';
       {0: begin // desing-time !!!
            FBtn.Caption := '...';
            Icon16 := NewIcon;
            Icon16.Size := 16;
            Bmp.Handle := 0;
            LoadFromBitmap(Bmp,Icon16,Color2RGB(FBtn.Color));
            FBtn.SetButtonIcon(Icon16.Handle);
            Icon16.Free;
          end;}


       1: FBtn.SetButtonIcon(iOpenIcon.Handle);
       2: FBtn.SetButtonIcon(iSaveIcon.Handle);
       3: FBtn.SetButtonIcon(iBrowseIcon.Handle);
       4: begin
            ExtractIconEx('shell32.dll',_prop_IconIdx,Licon,sIcon,1);
            DrawIconEx(Bmp.Canvas.Handle,0,0,sIcon,16,16,1,0,DI_NORMAL);
            Icon16 := NewIcon;
            Icon16.Size := 16;
            LoadFromBitmap(Bmp,Icon16,Control.Color);
            FBtn.SetButtonIcon(Icon16.Handle);
            Icon16.Free;
          end;
       5: begin
            ExtractIconEx('imageres.dll',_prop_IconIdx,Licon,sIcon,1);
            DrawIconEx(Bmp.Canvas.Handle,0,0,sIcon,16,16,1,0,DI_NORMAL);
            Icon16 := NewIcon;
            Icon16.Size := 16;
            LoadFromBitmap(Bmp,Icon16,Control.Color);
            FBtn.SetButtonIcon(Icon16.Handle);
            Icon16.Free;
          end;
       6: begin
            Icon16 := NewIcon;
            Icon16.Size := 16;
            Bmp.Handle := _prop_UseIcon;
            LoadFromBitmap(Bmp,Icon16,Color2RGB(FBtn.Color));
            FBtn.SetButtonIcon(Icon16.Handle);
            Icon16.Free;
          end;
     end;

     Bmp.Free;
     FBtn.OnClick := OnClick;
     FBtn.Invalidate;
   end;
end;

procedure THIEditEx.CalcRect;
var
  w,h: integer;
begin
  if (_prop_CapPosition = 0) and (_prop_akRight = True) then
  begin
    w := Fparent.Canvas.TextWidth(_prop_Caption);
    _prop_Width := _prop_Width - w;
    _prop_Left := _prop_Left + w;
  end;
  //top
  if _prop_CapPosition = 1 then
  begin
    h := Fparent.Canvas.TextHeight(_prop_Caption);
    _prop_Height := Max(24,h);
    _prop_Top := _prop_Top + h;
  end;
  //right
  if (_prop_CapPosition = 2) and (_prop_akRight = True)  then
  begin
    w := Fparent.Canvas.TextWidth(_prop_Caption);
    _prop_Width := _prop_Width - w;
  end;

end;

procedure THIEditEx.Init;
var
  fl: TEditOptions;
  R: TRect;
  dt: TData;
  w,h: integer;
begin
   CalcRect;

//   if _prop_Password then
   fl := [eoPassword];
//   else fl := [];
   if (_prop_Caption <> '') and (_prop_Align = caTop) then
     FCaption := NewLabel(FParent,_prop_Caption);

   if _prop_ReadOnly then
    Include(Fl,eoReadonly);

   Control := NewEditbox(FParent,fl);
   Control.TextAlign := TTextAlign(_prop_Alignment);
   //Control.ExStyle := Control.ExStyle or WS_EX_COMPOSITED; !!!
   inherited;
   Control.Perform(EM_LIMITTEXT,_prop_MaxLenField, 0);
   Control.OnChange := _OnChange;
   Control.Text := _prop_Text;
   Control.SubClassName := 'obj_EditControl';

   FPB := NewPaintBox(Control);
   FPB.Color := Control.Color;
   FPB.Width := Control.Height;
   //FPB.Height := Control.Height;
   FPB.Align := caLeft;
   //FPB.Top := 0;
   //FPB.Left := 0;

   SetHelp;

   FOld := _prop_Text;
   IdxPassSym := Control.Perform(EM_GETPASSWORDCHAR, 0, 0);
   if not _prop_Password then
     Control.Perform(EM_SETPASSWORDCHAR, 0, 0);

   if _prop_Caption <> '' then
   begin
     if _prop_Align <> caTop then
       FCaption := NewLabel(FParent,_prop_Caption);
     FCaption.Autosize(True);
     FCapFont := NewFont;
     TFontToGFont(_prop_FontCaption,FCapFont);
     FCaption.Font.Assign(FCapFont);

     //left
     if _prop_CapPosition = 0 then
     begin
       FCaption.TextAlign := taRight;
       FCaption.Left := Control.Left;
       FCaption.Top := Control.Top;
       //FCaption.Canvas.Font.Assign(FCaption.Font);
       w := FCaption.Canvas.TextWidth(_prop_Caption)+5;
       Control.Width :=  Control.Width-w;
       Control.Left := Control.Left + w;
     end;
     //top
     if _prop_CapPosition = 1 then
     begin
       if (Control.Align = caTop) then
         FCaption.Align := caTop;
       if (Control.Align = caBottom) then
         FCaption.Align := caBottom;
       h := FCaption.Canvas.TextHeight(_prop_Caption);
       Control.Top := Control.Top + h;
       FCaption.BringToFront;
       FCaption.TextAlign := taLeft;
       FCaption.Left := Control.Left;
       FCaption.Top := Control.Top - FCaption.Height;
       Control.Height := Max(24,h);
     end;
     //right
     if _prop_CapPosition = 2 then
     begin
       w := FCaption.Canvas.TextWidth(_prop_Caption)+5;
       FCaption.TextAlign := taLeft;
       Control.Width := Control.Width - w;
       FCaption.Left := (Control.Left+Control.Width)+5;
       FCaption.Top := Control.Top;
       _prop_Width := Control.Width;
     end;

   end;

  FtxtMarg := Control.Perform(EM_GETMARGINS,0,0);

  AddBtn;

  FPB.OnPaint := _OnPaint;
  FPB.OnEraseBkgnd := OnEraseBkgnd;

  dtInteger(dt,_prop_ValidIdx);
  _work_doValidInput(dt,0);

  FPB.Invalidate;

  FCapInit := True;
end;

procedure THIEditEx._work_doText;
var p:integer;
begin
   p := Control.SelStart;
   Control.Text := ReadString(_Data,_data_Str,'');
   Control.SelStart := p;
end;

procedure THIEditEx._work_doText2;
begin
   ChangeEvent := false;
   _work_doText(_Data,0);
end;

procedure THIEditEx._work_doPosition;
begin
   Control.SelStart := ToInteger(_Data);
end;

procedure THIEditEx._work_doSelectText;
begin
   Control.Selection := Share.ToString(_Data);
end;

procedure THIEditEx._work_doSelectAll;
begin
   Control.SelectAll;
end;

procedure THIEditEx._work_doSelectLength;
begin
   Control.SelLength := ToInteger(_Data);
end;

procedure THIEditEx._var_Text;
begin
   if not _prop_DataType(_Data) then
      dtNull(_Data);
end;

function isHex(const s:string; var dt:TData):boolean;
var i,N:integer;
begin
   Result := false;
   if s = '' then Exit;
   N := 0;
   for i := 1 to Length(s) do
     case s[i] of
      '0'..'9': N := N shl 4 + ord(s[i]) - 48;
      'a'..'f': N := N shl 4 + ord(s[i]) - 87;
      else Exit;
     end;
   Result := true;
   dtInteger(dt,N);
end;

function isNumeric(const s:string; var dt:TData):boolean;
var i:integer;
begin
   Result := false;
   if s = '' then Exit;
   for i := 1 to Length(s) do
     if not(s[i] in['0'..'9'])then Exit;
   Result := true;
   dtInteger(dt,Str2Int(s));
end;

function isFloat(const s:string; var dt:TData):boolean;
var i,j:integer;
begin
   Result := false;
   i := 1;
   if i>Length(s) then Exit;
   if s[i] in['+','-'] then inc(i);j:=i;
   if (i>Length(s))or(not(s[i]in['.','0'..'9'])) then Exit;
   while (i<=Length(s))and(s[i]in['0'..'9']) do inc(i);
   if s[i]='.' then begin
     inc(i);
     while (i<=Length(s))and(s[i]in['0'..'9']) do inc(i);
     if Copy(s,j,i-j)='.' then Exit;
   end;
   while (i<=Length(s))and(s[i]in[' ',#9]) do inc(i);
   if (i<=Length(s))and(s[i]='e') then begin
     inc(i);
     while (i<=Length(s))and(s[i]in[' ',#9]) do inc(i);
     if (i<=Length(s))and(s[i]in['+','-']) then begin
       inc(i);
       while (i<=Length(s))and(s[i]in[' ',#9]) do inc(i);
     end;
     if (i>Length(s))or(not(s[i]in['0'..'9'])) then Exit;
     while(i<=Length(s))and(s[i]in['0'..'9']) do inc(i);
   end;
   if i<=Length(s) then Exit;
   Result := True;
   dtReal(dt, Str2Double(s));
end;

function isInteger(const s:string; var dt:TData):boolean;
begin
   Result := false;
   if s = '' then Exit;
   if s[1] in ['+','-'] then begin
     Result := isNumeric(Copy(s,2,Length(s)-1),dt);
     if s[1] = '-' then dtInteger(dt,-Tointeger(dt));
   end
   else if s[1]='$' then
     Result := isHex(Copy(s,2,Length(s)-1),dt)
   else if (Length(s)>1)and(s[1]='0')and(s[2]='x') then
     Result := isHex(Copy(s,3,Length(s)-2),dt)
   else Result := isNumeric(s,dt);
end;

function THIEditEx.NoText;
var s:string;
    st:integer;
begin
   s := Control.Text;
   st := Control.SelStart;
   Result := func(LowerCase(s),dt);
   if Result then
     begin
      FPos := st;
      Fold := s;
      Exit;
     end
   else if not func(LowerCase(s)+'0',dt) then
     begin
      ChangeEvent := false; // Onoaiiaea Control.Text aucuaaao _OnChange !!!
      Control.Text := FOld;
      Control.SelStart := FPos;
     end
   else if s = '' then
     begin
      ChangeEvent := _prop_OnChngDelNumEnd;
      Control.Text := '0';
      FOld := '0';
     end;
end;

function THIEditEx.Number;
begin
  Result := NoText(isNumeric, dt);
end;

function THIEditEx.IntegerNumber;
begin
  Result := NoText(isInteger, dt);
end;

function THIEditEx.HexNumber;
begin
  Result := NoText(isHex, dt);
end;

function THIEditEx.FloatNumber;
begin
  Result := NoText(isFloat, dt);
end;

function THIEditEx.Text;
begin
   dtString(dt,Control.Text);
   Result := True;
end;

procedure THIEditEx._OnChange;
var dt:TData;
begin
   if ChangeEvent then
     if _prop_DataType(dt) then
       _hi_onEvent(_event_onChange,dt);
   ChangeEvent := true;
end;

(*
procedure THIEditEx._OnKeyDown;
var dt:TData;
begin
  if Assigned(_event_onEnter.Event) and (Key = 13) then
  begin
    if _prop_DataType(dt) then
    begin
      _hi_onEvent(_event_onEnter,dt);
      if _prop_ClearAfterEnter then
      begin
        ChangeEvent := false; // Onoaiiaea Control.Text aucuaaao _OnChange !!!
        Control.Text := '';
      end;
    end;
    Key := 0;
  end
  else
    inherited;
end;
*)

procedure THIEditEx._OnKeyDown;
var dt:TData;
begin
  if Key = 13 then begin
    if Assigned(_event_onEnter.Event) then begin
      if _prop_DataType(dt) then  begin
        _hi_onEvent(_event_onEnter,dt);
        if _prop_ClearAfterEnter then  begin
          ChangeEvent := false; // Onoaiiaea Control.Text aucuaaao _OnChange !!!
          Control.Text := '';
        end;
      end;
    end else inherited; // _event_onKeyDown
    Key := 0;
  end else inherited; // _event_onKeyDown
end;

function THIEditEx._fast_Text:string;
begin
    Result := Control.text;
end;

procedure THIEditEx._work_doReadOnly;
begin
  Control.Perform(EM_SETREADONLY, ToInteger(_Data), 0);
end;

procedure THIEditEx._work_doMaxLenField;
begin
  Control.Perform(EM_LIMITTEXT, ToInteger(_Data), 0);
end;

procedure THIEditEx._work_doPassword;
var
  epass: Boolean;
begin
  epass := ReadBool(_Data);
  if epass then
    Control.Perform(EM_SETPASSWORDCHAR, IdxPassSym, 0)
  else
    Control.Perform(EM_SETPASSWORDCHAR, 0, 0);
  Control.Invalidate;
end;

end.
